#ifndef ISOMMEPTR_H
#define ISOMMEPTR_H

#include "Relacheur.h"
#include <memory>
#include <string>

struct ISomme;

class erreur_creation {};
class erreur_calcul {};

class ISommePtr {
   std::unique_ptr<ISomme, relacheur> p;
public:
   ISommePtr(const std::wstring& = L"127.0.0.1");
   ~ISommePtr();
   ISommePtr(ISommePtr&&) = default;
   ISommePtr& operator=(ISommePtr&&) = default;
   int somme(int, int) const;
};

#endif
