#ifndef IUNKNOWNIMPL_H
#define IUNKNOWNIMPL_H

#include "IntrusiveShareable.h"
#include "GestionnaireDeVerrou.h"
#include <atomic>
#include <Unknwn.h>

struct IUnknownImpl : private IntrusiveShareable, IUnknown {
   IUnknownImpl() {
      GestionnaireDeVerrou::get().incrementer();
   }
   ~IUnknownImpl() {
      GestionnaireDeVerrou::get().decrementer();
   }
   unsigned long __stdcall AddRef() override {
      return add_ref();
   }
   unsigned long __stdcall Release() override {
      return release();
   }
};

#endif
