#include "GestionnaireDeVerrou.h"

// Dfinition du singleton
GestionnaireDeVerrou GestionnaireDeVerrou::singleton;
// Constructeur
GestionnaireDeVerrou::GestionnaireDeVerrou() : cptobj{ 0UL } {
}
// Oprations scurises sur le verrou
void GestionnaireDeVerrou::incrementer() {
   ++cptobj;
}
void GestionnaireDeVerrou::decrementer() {
   if (cptobj-- == 1)
      fin.notify_all();
}
// Consultation du verrou
bool GestionnaireDeVerrou::est_vide() const {
   return cptobj == 0;
}
